﻿using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using Microtoolskit.Hardware.Displays;

namespace NetduinoGirouette
{ // Titre Mesure de la direction du vent avec un kit Weather Sensor Assembly p/n 80422
    public class Program
    {
        public static void Main()
        {
            // Variables
            var Angle = 0;

            // Girouette connectée à l'entrée I0 de la carte Tinkerkit
            AnalogInput Girouette = new AnalogInput(Cpu.AnalogChannel.ANALOG_0);
            Girouette.Scale = 3.3; // Mise à l'échelle pour une tension d'alimentation U=3,3V

            // LCD à connecter sur la sortie O5 de la carte Tinkerkit           
            // Documentation de la classe ELCD162 : https://github.com/WebGE?tab=repositories
            // Création et initialisation d'un objet afficheur série ELCD-162 (par défaut: COM2, 19200, None, 8, 1)
            ELCD162 Lcd = new ELCD162(); Lcd.Init(); Lcd.ClearScreen();

            while (true)
            {
                var U_Girouette = Girouette.Read();

                if ((U_Girouette >= 0) & (U_Girouette < 0.45))
                {
                    Angle = 90;
                }
                else if ((U_Girouette >= 0.45) && (U_Girouette < 0.76))
                {
                    Angle = 135;
                }
                else if ((U_Girouette >= 0.76) && (U_Girouette < 1.21))
                {
                    Angle = 180;
                }
                else if ((U_Girouette >= 1.21) && (U_Girouette < 1.76))
                {
                    Angle = 45;
                }
                else if ((U_Girouette >= 1.76) && (U_Girouette < 2.28))
                {
                    Angle = 225;
                }
                else if ((U_Girouette >= 2.28) && (U_Girouette < 2.70))
                {
                    Angle = 0;
                }
                else if ((U_Girouette >= 2.70) && (U_Girouette < 2.95))
                {
                    Angle = 315;
                }
                else
                    Angle = 270;

                Lcd.ClearScreen(); Lcd.PutString("Angle=" + Angle + "deg");
                Debug.Print("Tension = " + U_Girouette.ToString("N2") + "  Angle= " + Angle);
                Thread.Sleep(1000);
            }
        }
    }
}